using System;
using System.Collections.Generic;
using System.Text;
using NQueue.DataServices;
using NQueue.Entities;

namespace NQueue.BusinessServices.Jobs
{
    /// <summary>
    /// Manages host instances 
    /// </summary>
    public class HostInstanceManager
    {
        /// <summary>
        /// Inserts a new host instance into the database
        /// </summary>
        /// <param name="hostID">Host ID for the host the instance is associated with</param>
        /// <param name="serverName">Servername of the server the instance runs on </param>
        /// <returns></returns>
        public static void AddHostInstance(int hostID, string serverName)
        {
            DBHostInstance.InsertHostInstance(hostID, serverName);
        }
        
        
        private HostInstance _hostInstance;

        public HostInstanceManager(HostInstance hostInstance)
        {
            this._hostInstance = hostInstance;
        }

        public void Delete()
        {
            DBHostInstance.DeleteHostInstance(_hostInstance.HostInstanceID);
        }

        public static HostInstance GetHostInstance(int hostInstanceID)
        {
            return DBHostInstance.GetHostInstance(hostInstanceID);
        }
    }
}
