using System;
using System.Collections.Generic;
using System.Text;
using NQueue.Entities;
using NQueue.DataServices;

namespace NQueue.BusinessServices.Jobs
{
    /// <summary>
    /// Manages host information
    /// </summary>
    public class HostManager
    {
        private Host _host;

        public HostManager(Host host)
        {
            this._host = host;
        }
        /// <summary>
        /// Returns all host instances for a host
        /// </summary>
        /// <returns></returns>
        public List<HostInstance> GetHostInstances()
        {
            return DBHostInstance.GetAllHostInstances(_host.HostID);
        }
        /// <summary>
        /// Deletes a host
        /// </summary>
        public void DeleteHost()
        {
            if (DBHostInstance.GetAllHostInstances(_host.HostID).Count > 0)
                throw new InvalidOperationException("Cannot delete the host as it is associated with one or more instances");
            DBHost.DeleteHost(_host.HostID);
        }

        public static void AddHost(string hostName)
        {
            DBHost.InsertHost(hostName);
        }

        /// <summary>
        /// Returns all hosts currently defined
        /// </summary>
        /// <returns></returns>
        public static List<Host> GetAllHosts()
        {
            return DBHost.GetAllHosts();
        }




    }
}
