using System;
using System.Collections.Generic;
using System.Text;
using NQueue.DataServices;
using NQueue.Entities;

namespace NQueue.BusinessServices.System
{
    public class WorkLogReader
    {
        /// <summary>
        /// Gets a list of all items in the queue, regardless of status and including past items,
        /// ordered in reverse order of enqueue time
        /// </summary>
        /// <param name="jobInstanceID"></param>
        /// <returns></returns>
        public static List<WorkQueueItem> GetWorkQueueForJobInstance(int jobInstanceID)
        {
            return DBWorkLogReader.GetWorkQueueForJobInstance(jobInstanceID);
        }

        /// <summary>
        /// Gets all logs for a work queue item that has been dequeued
        /// </summary>
        /// <param name="workQueueItemID"></param>
        /// <returns></returns>
        public static List<WorkLogItem> GetLogsForWorkQueueItem(long workQueueItemID)
        {
            return DBWorkLogReader.GetLogsForWorkQueueItem(workQueueItemID);
        }
    }
}
