using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace NQueue.Client
{
    public class EventLogger
    {
        public const string EVENTLOGSOURCE = "NQueue";
        /// <summary>
        /// Writes information to the event log
        /// </summary>
        /// <param name="message"></param>
        public static void LogInformationEvent(string message) 
        {
            EventLog.WriteEntry(EVENTLOGSOURCE, message, EventLogEntryType.Information);
        }

        public static void LogErrorEvent(string message)
        {
            EventLog.WriteEntry(EVENTLOGSOURCE, message, EventLogEntryType.Error);
        }

        public static void LogErrorEvent(string message, Exception exc)
        {
            LogErrorEvent(string.Format("Error:\n{0}\nException:\n{1}\n{2}\n{3}", message, exc.Message, exc, exc.StackTrace));
        }

        public static void EnsureEventSource()
        {
            // Create the source, if it does not already exist.
            if (!EventLog.SourceExists(EVENTLOGSOURCE))
            {
                EventLog.CreateEventSource(EVENTLOGSOURCE, "Application");
            }

        }
    }
}
