using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace NQueue.Client.LoggingStrategies
{
    [Serializable]
    public class DebugLoggingStrategy : IExecutionLoggingStrategy
    {
        #region IExecutionLoggingStrategy Members

        public void WriteInfo(string description)
        {
            Debug.WriteLine("INFO: " + description);
        }

        public void WriteWarning(string description)
        {
            Debug.WriteLine("WARNING: " + description);
        }

        public void WriteError(string description)
        {
            Debug.WriteLine("ERROR: " + description);
        }

        public void WriteError(string description, Exception exception)
        {
            Debug.WriteLine(string.Format("ERROR: {0}. Exception: {1} - {2}", description, exception.Message, exception.StackTrace));
        }

        #endregion
    }
}
