using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace NQueue.DataServices
{
    public class SerialisationHelper
    {
        /// <summary>
        /// XML serialises an object
        /// </summary>
        /// <param name="objectToSerialise"></param>
        /// <returns></returns>
        public static string SerialiseObject(object objectToSerialise)
        {
            XmlSerializer ser = new XmlSerializer(objectToSerialise.GetType());
            MemoryStream serialisedObject = new MemoryStream();
            ser.Serialize(serialisedObject, objectToSerialise);
            return Encoding.UTF8.GetString(serialisedObject.ToArray());
        }

        public static object DeserialiseObject(string serialisedObject, Type objectType)
        {
            //deserialise the parameter object
            byte[] buffer = Encoding.UTF8.GetBytes(serialisedObject);
            MemoryStream stringAsStream = new MemoryStream(buffer, 0, buffer.Length, true, true);
            XmlSerializer serializer = new XmlSerializer(objectType);
            return serializer.Deserialize(stringAsStream);
        }
    }
}
