using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    public class DequeuedJob
    {
        private int _jobDefinitionId;
        private int _jobInstanceID;
        private string _jobName;
        private string _jobDescription;
        private string _jobAssemblyStrongName;
        private string _jobClassType;
        private string _jobConfigurationFile;


        /// <summary>
        /// ID of the job definition
        /// </summary>
        public int JobDefinitionID
        {
            get
            {
                return _jobDefinitionId;
            }
            set
            {
                _jobDefinitionId = value;
            }
        }

        /// <summary>
        /// Name of the job definition
        /// </summary>
        public string JobName
        {
            get
            {
                return _jobName;
            }
            set
            {
                _jobName = value;  
            }
        }

        /// <summary>
        /// Long description of the job
        /// </summary>
        public string JobDescription
        {
            get
            {
                return _jobDescription;
            }
            set
            {
                _jobDescription = value;
            }
        }

        /// <summary>
        /// Strong name of the assembly containing the class implementing the job
        /// </summary>
        public string JobAssemblyStrongName
        {
            get
            {
                return _jobAssemblyStrongName;
            }
            set
            {
                _jobAssemblyStrongName = value;
            }
        }

        /// <summary>
        /// Typename of the type that implements the job
        /// </summary>
        public string JobClassType
        {
            get
            {
                return _jobClassType;
            }
            set
            {
                _jobClassType = value;
            }
        }

        /// <summary>
        /// Optional full path and filename to the configuration file to be used when the job instance executes
        /// </summary>
        public string JobConfigFile
        {
            get
            {
                return _jobConfigurationFile;
            }
            set
            {
                _jobConfigurationFile = value;
            }
        }

        /// <summary>
        /// ID of the job instance
        /// </summary>
        public int JobInstanceID
        {
            get
            {
                return _jobInstanceID;
            }
            set
            {
                _jobInstanceID = value;
            }
        }
    }
}
