using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Represents a host instance - a mapping between a server and a host (a server running a host)
    /// </summary>
    public class HostInstance 
    {


        private int _hostID;
        private string _hostName;

        /// <summary>
        /// Database ID of the host this instance is an instance of
        /// </summary>
        public int HostID
        {
            get { return _hostID; }
            set { _hostID = value; }
        }
        /// <summary>
        /// Name of the host this instance is an instance of
        /// </summary>
        public string HostName
        {
            get { return _hostName; }
            set { _hostName = value; }
        }

        private int _hostInstanceID;
        /// <summary>
        /// Database ID for the host instance
        /// </summary>
        public int HostInstanceID
        {
            get { return _hostInstanceID; }
            set { _hostInstanceID = value; }
        }
        private string _serverName;
        /// <summary>
        /// Server name the host is mapped to to produce this instance
        /// </summary>
        public string ServerName
        {
            get { return _serverName; }
            set { _serverName = value; }
        }

    }
}
