using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Defines a job that can be executed
    /// </summary>
    public class JobDefinition 
    {
        private int _jobDefinitionID;
        /// <summary>
        /// Database ID for the job
        /// </summary>
        public int JobDefinitionID
        {
            get { return _jobDefinitionID; }
            set { _jobDefinitionID = value; }
        }
        private string _jobName;
        /// <summary>
        /// Name of the job
        /// </summary>
        public string JobName
        {
            get { return _jobName; }
            set { _jobName = value; }
        }
        private string _jobDescription;
        /// <summary>
        /// Long description of the job
        /// </summary>
        public string JobDescription
        {
            get { return _jobDescription; }
            set { _jobDescription = value; }
        }
        private string _jobAssemblyStrongName;
        /// <summary>
        /// Strong name of the assembly containing the job's implementation
        /// </summary>
        public string JobAssemblyStrongName
        {
            get { return _jobAssemblyStrongName; }
            set { _jobAssemblyStrongName = value; }
        }
        private string _jobClassType;
        /// <summary>
        /// Type name for the type containing the job's implementation
        /// </summary>
        public string JobClassType
        {
            get { return _jobClassType; }
            set { _jobClassType = value; }
        }
        private string _jobConfigFile;
        /// <summary>
        /// Optional config file to be applied to the class whilst it's being executed
        /// </summary>
        public string JobConfigFile
        {
            get { return _jobConfigFile; }
            set { _jobConfigFile = value; }
        }

        public override string ToString()
        {
            return JobName;
        }


    }
}
