using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Represents a scheduled job instance
    /// </summary>
    public class JobInstanceSchedule
    {
        private int _jobInstanceScheduleID;
        /// <summary>
        /// Job instance schedule ID - PK from the database
        /// </summary>
        public int JobInstanceScheduleID
        {
            get { return _jobInstanceScheduleID; }
            set { _jobInstanceScheduleID = value; }
        }

        private int _jobInstanceID;
        /// <summary>
        /// Job instance this is a schedule for
        /// </summary>
        public int JobInstanceID
        {
            get { return _jobInstanceID; }
            set { _jobInstanceID = value; }
        }

        private int _scheduleTypeID;
        /// <summary>
        /// Schedule type this is for
        /// </summary>
        public int ScheduleTypeID
        {
            get { return _scheduleTypeID; }
            set { _scheduleTypeID = value; }
        }

        private string _scheduleParameters;
        /// <summary>
        /// Parameters for the schedule type - serialised parameters object
        /// </summary>
        public string ScheduleParameters
        {
            get { return _scheduleParameters; }
            set { _scheduleParameters = value; }
        }

        private DateTime? _instanceScheduleLastRun;
        /// <summary>
        /// When the job instance schedule was last run
        /// </summary>
        public DateTime? InstanceScheduleLastRun
        {
            get { return _instanceScheduleLastRun; }
            set { _instanceScheduleLastRun = value; }
        }

        private string _scheduleTypeName;
        /// <summary>
        /// Name of the schedule type this instance represents
        /// </summary>
        public string ScheduleTypeName
        {
            get { return _scheduleTypeName; }
            set { _scheduleTypeName = value; }
        }

        private bool _jobInstanceScheduleWasJustProcessed = false;
        /// <summary>
        /// If this job instance schedule has been processed since it was retrieved from the database
        /// this will be set to true
        /// </summary>
        public bool JobInstanceScheduleWasJustProcessed
        {
            get { return _jobInstanceScheduleWasJustProcessed; }
            set { _jobInstanceScheduleWasJustProcessed = value; }
        }


    }
}
