
using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// All possible states a job instance can be in
    /// </summary>
    public enum JobInstanceStates
    {
        /// <summary>
        /// Job instance is enabled and queued work should be run
        /// </summary>
        Enabled = 1,
        /// <summary>
        /// Job instance is disabled and queued work should be dequeued and not run
        /// </summary>
        Disabled = 2,
        /// <summary>
        /// Job instance is paused and queued work should not be dequeued.  The work will
        /// be dequeued when the job instance state is changed
        /// </summary>
        Paused = 3
    }
}
