using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Represents a type of schedule
    /// </summary>
    public class ScheduleType
    {
        private int _scheduleTypeID;
        /// <summary>
        /// Database ID for the schedule type
        /// </summary>
        public int ScheduleTypeID
        {
            get { return _scheduleTypeID; }
            set { _scheduleTypeID = value; }
        }
        private string _scheduleTypeName;
        /// <summary>
        /// Name of the schedule type
        /// </summary>
        public string ScheduleTypeName
        {
            get { return _scheduleTypeName; }
            set { _scheduleTypeName = value; }
        }
        private bool _currentlyProcessing;
        /// <summary>
        /// True if the type is currently being processed by some host instance
        /// </summary>
        public bool CurrentlyProcessing
        {
            get { return _currentlyProcessing; }
            set { _currentlyProcessing = value; }
        }
        private DateTime? _lastProcessed;
        /// <summary>
        /// Date and time the schedule type was last processed
        /// </summary>
        public DateTime? LastProcessed
        {
            get { return _lastProcessed; }
            set { _lastProcessed = value; }
        }
        private DateTime? _nextProcessDue;
        /// <summary>
        /// Date and time the schedule type is next due to be processed
        /// </summary>
        public DateTime? NextProcessDue
        {
            get { return _nextProcessDue; }
            set { _nextProcessDue = value; }
        }
        private int? _processingHostInstanceID;
        /// <summary>
        /// If currently being processed, the host instance ID doing the processing
        /// </summary>
        public int? ProcessingHostInstanceID
        {
            get { return _processingHostInstanceID; }
            set { _processingHostInstanceID = value; }
        }

        private string _scheduleTypeStrongName;

        /// <summary>
        /// Assembly name of the assembly containing the class that backs the schedule type
        /// </summary>
        public string ScheduleTypeStrongName
        {
            get { return _scheduleTypeStrongName; }
            set { _scheduleTypeStrongName = value; }
        }
        private string _scheduleTypeClassType;
        /// <summary>
        /// Type name of the class that backs the schedule type
        /// </summary>
        public string ScheduleTypeClassName
        {
            get { return _scheduleTypeClassType; }
            set { _scheduleTypeClassType = value; }
        }
        public override string ToString()
        {
            return ScheduleTypeName;
        }

    }
}
