using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Represents the configuration of the batch system at this point in time
    /// </summary>
    public class SystemConfiguration
    {
        private List<Host> _hosts;
        /// <summary>
        /// All hosts defined in the system
        /// </summary>
        public List<Host> Hosts
        {
            get { return _hosts; }
            set { _hosts = value; }
        }
        private List<HostInstance> _hostInstances;
        /// <summary>
        /// All host instances defined on the system
        /// </summary>
        public List<HostInstance> HostInstances
        {
            get { return _hostInstances; }
            set { _hostInstances = value; }
        }
        private List<JobDefinition> _jobDefinitions;
        /// <summary>
        /// All job definitions defined on the system
        /// </summary>
        public List<JobDefinition> JobDefinitions
        {
            get { return _jobDefinitions; }
            set { _jobDefinitions = value; }
        }
        private List<JobInstance> _jobInstances;
        /// <summary>
        /// All job instances defined on the system
        /// </summary>
        public List<JobInstance> JobInstances
        {
            get { return _jobInstances; }
            set { _jobInstances = value; }
        }
        

    }
}
