using System;
using System.Collections.Generic;
using System.Text;

namespace NQueue.Entities
{
    /// <summary>
    /// Represents a work item that should be enqueued to the work queue
    /// </summary>
    public class WorkItemToEnqueue
    {
        public WorkItemToEnqueue(int jobInstanceID, DateTime dateToExecute)
        {
            this._jobInstanceID = jobInstanceID;
            this._dateToExecute = dateToExecute;
        }

        private string _serverAffinity;
        /// <summary>
        /// If not null or blank, the work item should only be dequeued on the given server
        /// </summary>
        public string ServerAffinity
        {
            get { return _serverAffinity; }
            set { _serverAffinity = value; }
        }

        private int _jobInstanceID;
        /// <summary>
        /// Job instance ID of the job instance to enqueue
        /// </summary>
        public int JobInstanceID
        {
            get { return _jobInstanceID; }
            set { _jobInstanceID = value; }
        }
        private DateTime _dateToExecute;

        /// <summary>
        /// Date and time before which the work item should not be dequeued
        /// </summary>
        public DateTime DateToExecute
        {
            get { return _dateToExecute; }
            set { _dateToExecute = value; }
        }


    }
}
