using System;
using System.Collections.Generic;
using System.Text;
using NQueue.Client.Entities;

namespace NQueue.Entities
{
    /// <summary>
    /// Represent a logged event for a work item to be displayed on the batch admin website
    /// </summary>
    public class WorkLogItem
    {
        private Guid _workLogItemID;

        public Guid WorkLogItemID
        {
            get { return _workLogItemID; }
            set { _workLogItemID = value; }
        }
        private long _workItemID;

        public long WorkItemID
        {
            get { return _workItemID; }
            set { _workItemID = value; }
        }
        private WorkLogTypes _workLogType;

        public WorkLogTypes WorkLogType
        {
            get { return _workLogType; }
            set { _workLogType = value; }
        }
        private DateTime _logTime;

        public DateTime LogTime
        {
            get { return _logTime; }
            set { _logTime = value; }
        }
        private string _statusDescription;

        public string StatusDescription
        {
            get { return _statusDescription; }
            set { _statusDescription = value; }
        }
        private string _exceptionStackTrace;

        public string ExceptionStackTrace
        {
            get { return _exceptionStackTrace; }
            set { _exceptionStackTrace = value; }
        }

        public static WorkLogTypes IntToWorkLogType(int workLogTypeID)
        {
            switch (workLogTypeID)
            {
                case 1:
                    return WorkLogTypes.Information;
                case 2:
                    return WorkLogTypes.Warning;
                case 3:
                    return WorkLogTypes.Error;
                default:
                    throw new InvalidOperationException("Did not recognise work log type for int");
            }
        }
    }

    
}
