﻿using NUnit.Framework;
using System;
using System.Text;
using System.Collections.Generic;
using NQueue.BusinessServices.Jobs;
using NQueue.Entities;
using NQueue.Client;
using NQueue.Client.LoggingStrategies;
namespace NQueue.UnitTests
{
    /// <summary>
    ///This is a test class for NQueue.BusinessServices.Jobs.IsolatedJobInvoker and is intended
    ///to contain all NQueue.BusinessServices.Jobs.IsolatedJobInvoker Unit Tests
    ///</summary>
    [TestFixture]
    public class IsolatedJobInvokerTest
    {



        /// <summary>
        ///A test for ExecuteJob (DequeuedJob)
        ///</summary>
        [Test]
        public void ExecuteJobTest()
        {
            IsolatedJobInvoker target = new IsolatedJobInvoker();

            DequeuedWorkItem job = new DequeuedWorkItem();
            job.JobAssemblyStrongName = "NQueue.UnitTests, Version=1.0.0.0, Culture=neutral, PublicKeyToken=d5f1da7c501d0b59";
            job.JobClassType = "NQueue.UnitTests.TestJobType";
            job.JobDefinitionID = 1;
            job.JobInstanceID = 1;
            job.JobName = "Test Job Name";
            

            ExecutionResults expected = ExecutionResults.Success;
            ExecutionResults actual;

            actual = target.ExecuteJob(job, new DebugLoggingStrategy());

            Assert.AreEqual(expected, actual, "NQueue.BusinessServices.Jobs.IsolatedJobInvoker.ExecuteJob did not return the exp" +
                    "ected value.");

        }




        /// <summary>
        ///A test for ExecuteJob (DequeuedJob)
        ///</summary>
        [Test]
        public void ExecuteJobTestConfigFile()
        {
            IsolatedJobInvoker target = new IsolatedJobInvoker();

            DequeuedWorkItem job = new DequeuedWorkItem();
            job.JobAssemblyStrongName = "NQueue.UnitTests, Version=1.0.0.0, Culture=neutral, PublicKeyToken=d5f1da7c501d0b59";
            job.JobClassType = "NQueue.UnitTests.TestJobTypeConfigFile";
            job.JobDefinitionID = 1;
            job.JobInstanceID = 1;
            job.JobName = "Test Job Name";
            job.JobConfigFile = @"..\..\TestBatchJobConfiguration.dll.config";


            ExecutionResults expected = ExecutionResults.Success;
            ExecutionResults actual;

            actual = target.ExecuteJob(job, new DebugLoggingStrategy());

            Assert.AreEqual(expected, actual, "NQueue.BusinessServices.Jobs.IsolatedJobInvoker.ExecuteJob did not return the exp" +
                    "ected value.");
        }
    }


}
