using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using NQueue.Entities;
using NQueue.BusinessServices.System;
using System.ServiceProcess;
using System.IO;

namespace NQueue
{
    public partial class ControlHostInstance : Form
    {

    
        private Label label1;
        private Label lblStatus;
        private Button btnInstall;
        private Button btnUninstall;
        private Button btnClose;
        private System.ServiceProcess.ServiceController serviceController;
        private Button btnRefresh;
        private Button btnStart;
        private Button btnStop;

        private HostInstance _hostInstance;

        public ControlHostInstance(HostInstance hostInstance)
        {
            this._hostInstance = hostInstance;
            InitializeComponent();
        }

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.btnClose = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.lblStatus = new System.Windows.Forms.Label();
            this.btnInstall = new System.Windows.Forms.Button();
            this.btnUninstall = new System.Windows.Forms.Button();
            this.serviceController = new System.ServiceProcess.ServiceController();
            this.btnRefresh = new System.Windows.Forms.Button();
            this.btnStart = new System.Windows.Forms.Button();
            this.btnStop = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // btnClose
            // 
            this.btnClose.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.btnClose.Location = new System.Drawing.Point(264, 102);
            this.btnClose.Name = "btnClose";
            this.btnClose.Size = new System.Drawing.Size(75, 23);
            this.btnClose.TabIndex = 0;
            this.btnClose.Text = "Close";
            this.btnClose.UseVisualStyleBackColor = true;
            this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(2, 4);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(40, 13);
            this.label1.TabIndex = 1;
            this.label1.Text = "Status:";
            // 
            // lblStatus
            // 
            this.lblStatus.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.lblStatus.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
            this.lblStatus.Location = new System.Drawing.Point(2, 17);
            this.lblStatus.Name = "lblStatus";
            this.lblStatus.Size = new System.Drawing.Size(256, 40);
            this.lblStatus.TabIndex = 2;
            this.lblStatus.Text = "Unknown";
            // 
            // btnInstall
            // 
            this.btnInstall.Enabled = false;
            this.btnInstall.Location = new System.Drawing.Point(5, 60);
            this.btnInstall.Name = "btnInstall";
            this.btnInstall.Size = new System.Drawing.Size(75, 23);
            this.btnInstall.TabIndex = 3;
            this.btnInstall.Text = "Install";
            this.btnInstall.UseVisualStyleBackColor = true;
            this.btnInstall.Click += new System.EventHandler(this.btnInstall_Click);
            // 
            // btnUninstall
            // 
            this.btnUninstall.Enabled = false;
            this.btnUninstall.Location = new System.Drawing.Point(86, 60);
            this.btnUninstall.Name = "btnUninstall";
            this.btnUninstall.Size = new System.Drawing.Size(75, 23);
            this.btnUninstall.TabIndex = 4;
            this.btnUninstall.Text = "Uninstall";
            this.btnUninstall.UseVisualStyleBackColor = true;
            this.btnUninstall.Click += new System.EventHandler(this.btnUninstall_Click);
            // 
            // btnRefresh
            // 
            this.btnRefresh.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.btnRefresh.Location = new System.Drawing.Point(264, 12);
            this.btnRefresh.Name = "btnRefresh";
            this.btnRefresh.Size = new System.Drawing.Size(75, 23);
            this.btnRefresh.TabIndex = 5;
            this.btnRefresh.Text = "Refresh";
            this.btnRefresh.UseVisualStyleBackColor = true;
            this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
            // 
            // btnStart
            // 
            this.btnStart.Enabled = false;
            this.btnStart.Location = new System.Drawing.Point(5, 89);
            this.btnStart.Name = "btnStart";
            this.btnStart.Size = new System.Drawing.Size(75, 23);
            this.btnStart.TabIndex = 6;
            this.btnStart.Text = "Start";
            this.btnStart.UseVisualStyleBackColor = true;
            this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
            // 
            // btnStop
            // 
            this.btnStop.Enabled = false;
            this.btnStop.Location = new System.Drawing.Point(87, 89);
            this.btnStop.Name = "btnStop";
            this.btnStop.Size = new System.Drawing.Size(75, 23);
            this.btnStop.TabIndex = 7;
            this.btnStop.Text = "Stop";
            this.btnStop.UseVisualStyleBackColor = true;
            this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
            // 
            // ControlHostInstance
            // 
            this.ClientSize = new System.Drawing.Size(351, 137);
            this.Controls.Add(this.btnStop);
            this.Controls.Add(this.btnStart);
            this.Controls.Add(this.btnRefresh);
            this.Controls.Add(this.btnUninstall);
            this.Controls.Add(this.btnInstall);
            this.Controls.Add(this.lblStatus);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btnClose);
            this.Name = "ControlHostInstance";
            this.Text = "Control Host Instance Service";
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnInstall_Click(object sender, EventArgs e)
        {
            //get the user credentials under which to run the service
            ServiceCredentialsForm credForm = new ServiceCredentialsForm();
            if (credForm.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    //install the service
                    CustomServiceController.InstallService(_hostInstance, 
                        SystemManager.GetNQueueExecutablePath(_hostInstance),
                        credForm.UserName, credForm.Password);
                    RefreshServiceStatus();
                    MessageBox.Show("Service Installed", "Service Installed", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(string.Format("Error installing service:\n{0}\nStack Trace:\n{1}", exc.Message, exc.StackTrace), "Error installing service", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }

                
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            RefreshServiceStatus();
        }

        private void RefreshServiceStatus()
        {
            serviceController.ServiceName = SystemManager.GetNQueueServiceName(_hostInstance);
            serviceController.MachineName = _hostInstance.ServerName;
            try
            {
                ServiceControllerStatus serviceStatus = serviceController.Status;
                lblStatus.Text = serviceStatus.ToString();
                btnInstall.Enabled = false;
                btnUninstall.Enabled = true;
                switch (serviceStatus)
                {
                    case ServiceControllerStatus.Running:
                        btnStop.Enabled = true;
                        btnStart.Enabled = false;
                        break;
                    case ServiceControllerStatus.Stopped:
                        btnStop.Enabled = false;
                        btnStart.Enabled = true;
                        break;
                    default:
                        break;
                }
            }
            catch (InvalidOperationException exc)
            {
                //thrown when the service isn't installed
                lblStatus.Text = exc.Message;
                btnInstall.Enabled = true;
                btnUninstall.Enabled = false;
            }
            
        }

        private void btnUninstall_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Delete host instance windows service - are you sure?", "Delete host instance service", MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.OK)
            {
                try
                {
                    CustomServiceController.DeleteService(_hostInstance.ServerName, SystemManager.GetNQueueServiceName(_hostInstance));
                    RefreshServiceStatus();
                    MessageBox.Show("Service Deleted", "Service Deleted", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(string.Format("Error deleting service:\n{0}\nStack Trace:\n{1}", exc.Message, exc.StackTrace), "Error deleting service", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            serviceController.Start();
            serviceController.WaitForStatus(ServiceControllerStatus.Running);
            RefreshServiceStatus();
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            serviceController.Stop();
            serviceController.WaitForStatus(ServiceControllerStatus.Stopped);
            RefreshServiceStatus();
        }
    }
}
