using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using NQueue.Entities;
using NQueue.BusinessServices.Jobs;

namespace NQueue
{
    public partial class HostInstanceControl : NQueue.BaseEntityControl
    {
        public HostInstanceControl(bool newItem, RefreshRequired refreshRequired)
            : base(newItem, refreshRequired)
        {
            InitializeComponent();
        }

        private HostInstance _hostInstance;



        protected override void Add()
        {
            HostInstanceManager.AddHostInstance(((Host)cboHosts.SelectedItem).HostID, txtServerName.Text);
        }

        protected override void Delete()
        {
            if (MessageBox.Show("Delete host instance " + _hostInstance.HostName + ": " + _hostInstance.ServerName + ".  Are you sure?", "Delete Host Instance", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) == DialogResult.Yes)
            {
                //TODO: remove host instance service from server


                HostInstanceManager instanceManager = new HostInstanceManager(_hostInstance);
                instanceManager.Delete();
            }
        }

        private void HostInstanceControl_Load(object sender, EventArgs e)
        {

            cboHosts.DataSource = HostManager.GetAllHosts();
            
            if (!NewItem)
            {
                _hostInstance = (HostInstance)ControllableItem;
                txtServerName.Text = _hostInstance.ServerName;
                lblHostInstanceID.Text = _hostInstance.HostInstanceID.ToString();
                foreach (Host host in cboHosts.Items)
                {
                    if (host.HostID == _hostInstance.HostID)
                    {
                        cboHosts.SelectedItem = host;
                    }
                }
                btnControl.Enabled = true;
            }
            else
            {
                cboHosts.Enabled = true;
                txtServerName.ReadOnly = false;
            }
        }

        private void btnControl_Click(object sender, EventArgs e)
        {
            ControlHostInstance controlForm = new ControlHostInstance(_hostInstance);
            controlForm.ShowDialog();
        }
    }
}

