using System;
using System.Drawing;
using System.Reflection;
using System.Threading;
using System.Diagnostics;
using System.Windows.Forms;

namespace NQueue
{
    public partial class SplashScreen : Form
    {
        private delegate void CloseForm(Form frm);

        internal SplashScreen(string applicationName)
        {
            
            InitializeComponent();

            ////Fetch assembly name
            //AssemblyName assemName = new AssemblyName(Assembly.GetExecutingAssembly().FullName);

            //lblCopyright.Text = string.Format("NQueue Configuration{0}Version {1}{0}Customised Application- {2}", Environment.NewLine, assemName.Version, applicationName);


            //Set thread to close this window after sometime
            //ThreadPool.QueueUserWorkItem(new WaitCallback(CloseLogo), null);
        }

        public void Loaded()
        {
            ThreadPool.QueueUserWorkItem(new WaitCallback(CloseLogo), null);
        }

        /// <summary>
        /// This will close the logo window after configured time
        /// </summary>
        /// <param name="obj">not in use</param>
        private void CloseLogo(object obj)
        {
            Thread.Sleep(3000);
            if (this.InvokeRequired)
                Invoke(new CloseForm(CloseWindowsForm), this);
            else
                CloseWindowsForm(this);

        }

        /// <summary>
        /// This method is called by CloseLogo method to close the form window.
        /// </summary>
        /// <param name="frm"></param>
        private void CloseWindowsForm(Form frm)
        {
            //Add fade out style
            while(this.Opacity > 0)
            {
                this.Opacity = this.Opacity - .10;
                //Required to repaint the screen
                this.Refresh();
                Thread.Sleep(5);
            }

            //Close it finally
            frm.Close();
        } 
    }
}